<?php
namespace Neuron\Person\Controller;
use Neuron\Person\Medicals;
use Neuron\Person\Medical as MedicalModel;
use Neuron\Generic\Result;

class Medical extends \Neuron\Person\Controller {
	protected function getView($name, $variables = array()){
		/* default layout & view prefix */
		$layout = 'neuron/person/layout/form';
		$prefix = 'neuron/person/medical';

		/* libraries */
		$this->using('jquery', null, false)
		->using('bootstrap', null)
		->using('font-awesome', null)
		->using('bootbox');

		/* get layout n view prefix from config */
		$config = $this->getConfig();
		if (isset($config['task'])) {
		$config = $config['task'];
		$layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
		$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}


		// Script FCM
			$config = $this->getConfig();
	        $opt = new Notification\FCM\Options();
	        $opt->push($config['notification']['fcm']);
	        
	        $template = new Notification\Template(Notification\Template\Storage::factory($this->getDb(), $this->getConfig()));
	        
	        $fcm = new Notification\FCM(
	            Notification\Email\Storage::factory($this->getDb(), $this->getConfig()),
	            $template,
	            $opt
	        );
	        
	        $id_user = $this->userID();
	        $script = $fcm->listen('firebaseHandler', $id_user, $this->getPublicUrl());
			
		$variables['script'] = $script;

		/* set layout and view */
		$this->layout($layout);

		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name));

		return $view;
	}

	protected function getViewPartial($name, $variables = array()){
		$prefix = 'neuron/person/medical';
		$config = $this->getConfig();
		if (isset($config['task'])) {
			$config = $config['task'];
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name)); // path to phtml file under view folder
		return $view;
	}

	// Moved to /controller/widget/medical
	public function formAction()
	{
		$post = $this->getPostParams();
        $id = $post['id'];
        $person_id = $post['person_id'];
        $meddata = array();
        $title = "Create Medical History";

        $storage = \Neuron\Person\Parameter\Storage::factory($this->getDb(), $this->getConfig());
        $cpar = new \Neuron\Person\Parameters($storage);

        $post = $this->getPostParams();
        $arr = $cpar->listparam($post['param_ref_name']);
        $listtype = array();

        if ($arr) {
            foreach ($arr as $data) {
                if($data['param_ref_name'] == 'MEDICAL_TYPE'){
                    array_push($listtype, $data);
                }
            }
        }
        if($id){
            $storage = \Neuron\Person\Medical\Storage::factory($this->getDb(), $this->getConfig());
			$cmed = new \Neuron\Person\Medical($storage);
            $title = "Edit Medical History";
            if ($cmed->load($id))  {
                $meddata = $cmed->pull();
            }
        }
		return $this->getViewPartial('crud', get_defined_vars());
	}
	public function listAction() {
		$result = new Result();
        $session = $this->getSession()->get();
        $post = $this->getRest()->getParameters();


        $personId = $post['person_id'];
        try {
			$Medicals = new Medicals(MedicalModel\Storage::factory($this->getDb(),$this->getConfig()));
            $dataMedicals = $Medicals->load($personId, MedicalModel\Storage::LISTBY_PERSON_TYPE);
			$dataMedical  = $dataMedicals->data['list'];
			$dataSymptoms = [];
			$dataSurgery = [];
			$dataAllergy = [];
			$dataHereditary = [];
			if($dataMedical){
				foreach ($dataMedical as $med) {
					if($med['medical_type_id'] == '1'){
						$dataSymptoms[] = $med;
					}else if($med['medical_type_id'] == '2'){
						$dataSurgery[] = $med;
					}else if($med['medical_type_id'] == '3'){
						$dataAllergy[] = $med;
					}else{
						$dataHereditary[] = $med;
					}
				}
			}
            $result->data = ['dataSymptoms'=> $dataSymptoms, 'dataSurgery'=> $dataSurgery, 'dataAllergy'=> $dataAllergy, 'dataHereditary'=> $dataHereditary];
        } catch (\Exception $th) {
            $result->code = 500;
            $result->info = $this->translate("failed loading medical");
        }

        $requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 
		
		$responseResult = array(
			'guid' => $result->guid,
			'code' => $result->code,
			'info' => $result->info,
			'data' => $result->data
		); 
		
		$logparam['subject'] = 'API PERSON LIST EDUCATION';
		$logparam['identity'] = $personId ? $personId : '';
		$logparam['user'] = $session['user_id'] ? $session['user_id'] : '';
		$logparam['description'] = 'Log proses api person list medical';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode($responseResult);
		
		$this->writeLogAction($logparam);
		
        return $this->getREST()->getResponse($result);
	}

	public function loadAction() {
		$result = new Result();
        $session = $this->getSession()->get();
        $post = $this->getRest()->getParameters();


        $medical_id = $post['medical_id'];
        try {
            $medical = new MedicalModel(MedicalModel\Storage::factory($this->getDb(),$this->getConfig()));
            $medical->load($medical_id, MedicalModel\Storage::LOADBY_ID);
            $result->data = $medical->pull();
            
        } catch (\Exception $th) {
            $result->code = 500;
            $result->info = $this->translate("failed loading medical");
        }

        $requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 
		
		$responseResult = array(
			'guid' => $result->guid,
			'code' => $result->code,
			'info' => $result->info,
			'data' => $result->data
		); 
		
		$logparam['subject'] = 'API PERSON LOAD EDUCATION';
		$logparam['identity'] = $medical_id ? $medical_id : '';
		$logparam['user'] = $session['user_id'] ? $session['user_id'] : '';
		$logparam['description'] = 'Log proses person load medical';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode($responseResult);
		
		$this->writeLogAction($logparam);
		
        return $this->getREST()->getResponse($result);
	}

	public function saveAction() {
		$storage = \Neuron\Person\Medical\Storage::factory($this->getDb(), $this->getConfig());
		
		$post = $this->getRest()->getParameters();
	
		
		try {
            $Medical = new MedicalModel(MedicalModel\Storage::factory($this->getDb(),$this->getConfig()));
            $result = $Medical->create($post);
        } catch (\Exception $th) {
            $result->code = 500;
            $result->info = $this->translate("failed save medical");
        }

		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 

		$logparam['subject'] = 'PERSON SAVE MEDICAL';
		$logparam['identity'] = $this->getSession()->owner();;
		$logparam['data1'] = $result;
		$logparam['description'] = 'Log proses person save medical';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode($result);

		$this->writeLogAction($logparam);
		
		return $this->getRest()->getResponse($result);
	}

	public function deleteAction() {
		$result = new Result();
        $session = $this->getSession()->get();
        $post = $this->getRest()->getParameters();


        $medical_id = $post['medical_id'];
        try {
            $medical = new MedicalModel(MedicalModel\Storage::factory($this->getDb(),$this->getConfig()));
            $result = $medical->delete($medical_id);
        } catch (\Exception $th) {
            $result->code = 500;
            $result->info = $this->translate("failed loading relation");
        }

        $requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 
		
		$responseResult = array(
			'guid' => $result->guid,
			'code' => $result->code,
			'info' => $result->info,
			'data' => $result->data
		); 
		
		$logparam['subject'] = 'API PERSON DELETE MEDICAL';
		$logparam['identity'] = $medical_id ? $medical_id : '';
		$logparam['user'] = $session['user_id'] ? $session['user_id'] : '';
		$logparam['description'] = 'Log proses person delete medical';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode($responseResult);
		
		$this->writeLogAction($logparam);
		
        return $this->getREST()->getResponse($result);
	}


}
